<template>
  <div id="profile">
    <div id="profile-is-not-found-container" v-if="profileIsNotFound">
      Désolé ce profil est introuvable
    </div>
    <div id="profile-container" v-if="profileIsReady">
      <profile-header :profile="profile" :authed-profile="authedProfile"/>
      <profile-content :profile="profile" :authed-profile="authedProfile"/>
    </div>
  </div>
</template>
<script>
import profileHeader from '@/components/ProfileHeader'
import profileContent from '@/components/ProfileContent'
import { mapState } from 'vuex'
import Api from '@/api/Api'
export default {
  name: 'Profile',
  data() {
    return {
      routeUserName : this.$route.params.username,
      profile:{}
    }
  },
  components : {
    'profileHeader' : profileHeader,
    'profileContent' : profileContent
  },
  computed: {
    ...mapState('profile',['authedProfile']),
    isAuthedProfile(){
      return this.routeUserName===this.authedProfile.username
    },
    profileIsNotFound(){
      return this.profile == false
    },
    profileIsReady(){
      return Object.keys(this.profile).length>0 && Object.keys(this.authedProfile).length>0
    }
},
 methods : {
   fetchProfile(routeUserName){
     if(routeUserName){

       if(this.isAuthedProfile){
         this.profile = {... this.authedProfile};
       }else{
           Api.auth().post('/profile_by_username',{username:routeUserName}).then((res) =>
             {
                if(res.data.success){
                  this.profile =  res.data.user;
                }else {
                  this.profile=false;
                }
             }).catch((res) => {
               return res
             })
       }
     }

   },
 },
 created(){
   this.fetchProfile(this.routeUserName);
 },
 watch: {
    '$route' (to, from) {
      var newRoute = to.params.username;
      if(!newRoute){
        this.$router.replace({params: { username: this.authedProfile.username}})
        this.fetchProfile(this.authedProfile.username);
        return false;
      }

      this.routeUserName = newRoute;
      this.fetchProfile(newRoute);
    },
    authedProfile(val){
      if(val && !this.routeUserName){
        this.$router.replace({params: { username: val.username}})
        this.profile = val
      }
      if(this.isAuthedProfile){
        this.profile = val;
      }
    }
}
}
</script>
<style lang="scss">


</style>
